|
1
|
+#!/bin/bash
|
|
2
|
+#
|
|
3
|
+# Copyright 2018 Bloomberg Finance LP
|
|
4
|
+#
|
|
5
|
+# This program is free software; you can redistribute it and/or
|
|
6
|
+# modify it under the terms of the GNU Lesser General Public
|
|
7
|
+# License as published by the Free Software Foundation; either
|
|
8
|
+# version 2 of the License, or (at your option) any later version.
|
|
9
|
+#
|
|
10
|
+# This library is distributed in the hope that it will be useful,
|
|
11
|
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
12
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
|
|
13
|
+# Lesser General Public License for more details.
|
|
14
|
+#
|
|
15
|
+# You should have received a copy of the GNU Lesser General Public
|
|
16
|
+# License along with this library. If not, see <http://www.gnu.org/licenses/>.
|
|
17
|
+#
|
|
18
|
+# Authors:
|
|
19
|
+# Chadnan Singh <csingh43 bloomberg net>
|
|
20
|
+
|
|
21
|
+# This is a helper script to generate Docker images using checkouts of
|
|
22
|
+# BuildStream elements.
|
|
23
|
+
|
|
24
|
+usage() {
|
|
25
|
+ cat <<EOF
|
|
26
|
+
|
|
27
|
+USAGE: $(basename "$0") [-c BST_CMD] [-m MESSAGE] [-t TAG] [-h] ELEMENT
|
|
28
|
+
|
|
29
|
+Create a Docker image from bst checkout of an element.
|
|
30
|
+
|
|
31
|
+OPTIONS:
|
|
32
|
+ -c BST_CMD Path to BuildStream command (default: bst).
|
|
33
|
+ -m MESSAGE Commit message for the imported image.
|
|
34
|
+ -t TAG Tag of the imported image.
|
|
35
|
+ -h Print this help text and exit.
|
|
36
|
+
|
|
37
|
+EXAMPLES:
|
|
38
|
+
|
|
39
|
+ # Import hello.bst as a Docker image with tag "bst-hello" and message "hello"
|
|
40
|
+ $(basename "$0") -m hello -t bst-hello hello.bst
|
|
41
|
+
|
|
42
|
+ # Import hello.bst as a Docker image with tag "bst-hello" using bst-here
|
|
43
|
+ $(basename "$0") -c bst-here -t bst-hello hello.bst
|
|
44
|
+
|
|
45
|
+EOF
|
|
46
|
+ exit "$1"
|
|
47
|
+}
|
|
48
|
+
|
|
49
|
+die() {
|
|
50
|
+ echo "FATAL: $1" >&2
|
|
51
|
+ exit 1
|
|
52
|
+}
|
|
53
|
+
|
|
54
|
+bst_cmd=bst
|
|
55
|
+docker_import_cmd=(docker import)
|
|
56
|
+docker_image_tag=
|
|
57
|
+
|
|
58
|
+while getopts c:m:t:h arg
|
|
59
|
+do
|
|
60
|
+ case $arg in
|
|
61
|
+ c)
|
|
62
|
+ bst_cmd="$OPTARG"
|
|
63
|
+ ;;
|
|
64
|
+ m)
|
|
65
|
+ docker_import_cmd+=('-m' "$OPTARG")
|
|
66
|
+ ;;
|
|
67
|
+ t)
|
|
68
|
+ docker_image_tag="$OPTARG"
|
|
69
|
+ ;;
|
|
70
|
+ h)
|
|
71
|
+ usage 0
|
|
72
|
+ ;;
|
|
73
|
+ \?)
|
|
74
|
+ usage 1
|
|
75
|
+ esac
|
|
76
|
+done
|
|
77
|
+
|
|
78
|
+shift $((OPTIND-1))
|
|
79
|
+if [[ "$#" != 1 ]]; then
|
|
80
|
+ echo "$0: No element specified" >&2
|
|
81
|
+ usage 1
|
|
82
|
+fi
|
|
83
|
+element="$1"
|
|
84
|
+
|
|
85
|
+# Dump to a temporary file in the current directory.
|
|
86
|
+# NOTE: We use current directory to try to ensure compatibility with scripts
|
|
87
|
+# like bst-here, assuming that the current working directory is mounted
|
|
88
|
+# inside the container.
|
|
89
|
+
|
|
90
|
+checkout_tar="bst-checkout-$(basename "$element")-$RANDOM.tar"
|
|
91
|
+
|
|
92
|
+echo "INFO: Checking out $element ..." >&2
|
|
93
|
+$bst_cmd checkout --tar "$element" "$checkout_tar" || die "Failed to checkout $element"
|
|
94
|
+echo "INFO: Successfully checked out $element" >&2
|
|
95
|
+
|
|
96
|
+echo "INFO: Importing Docker image ..."
|
|
97
|
+"${docker_import_cmd[@]}" "$checkout_tar" "$docker_image_tag" || die "Failed to import Docker image from tarball"
|
|
98
|
+echo "INFO: Successfully import Docker image $docker_image_tag"
|
|
99
|
+
|
|
100
|
+echo "INFO: Cleaning up ..."
|
|
101
|
+rm "$checkout_tar" || die "Failed to remove $checkout_tar"
|
|
102
|
+echo "INFO: Clean up finished"
|